'on error resume next

dim adoConn

dim adoRS

dim counter


sub setup()
    'Assert.Trace "setup"
    set adoConn = CreateObject("ADODB.Connection")
    set adoRS = CreateObject("ADODB.Recordset")
    adoConn.Open("FILEDSN=C:\src\ado-regression-tests\Bug3780.dsn")
    adoRS.ActiveConnection = adoConn
    Assert.IsEqual adoConn.errors.count, 0, "ERROR: Couldn't connect to database"
end sub

sub teardown()
    'Assert.Trace "teardown"
    adoConn.Execute "DROP TABLE IF EXISTS simpleTest"
    adoConn.Close
end sub

sub TestDefaultDatabase()
    'Assert.Trace "TestHello"

    adoConn.DefaultDatabase="test"
    
    'I wish to move table creation into function so we may track the table names for teardown.
    adoConn.Execute "DROP TABLE IF EXISTS simpleTest"
    adoConn.Execute "CREATE TABLE simpleTest(id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT, foo TEXT NOT NULL, PRIMARY KEY(id)) CHARACTER SET utf8 ENGINE=InnoDB"

    adoConn.Execute "Insert into simpleTest VALUES(NULL, 'Hello, World.')"
    adoConn.Execute "Insert into simpleTest VALUES(NULL, 'foo')"
    adoConn.Execute "Insert into simpleTest VALUES(NULL, 'bar')"

    adoRS.Open "SELECT * FROM simpleTest"

    checkSimpleTestRow 1, "Hello, World."
    checkSimpleTestRow 2, "foo"
    checkSimpleTestRow 3, "bar"

    Assert.IsTrue adoRS.EOF
end sub

sub checkSimpleTestRow(id, str)
    'Assert.Trace str
    Assert.IsFalse adoRS.EOF
    Assert.IsEqual adoRS.fields(0).value, id
    Assert.IsEqual adoRS.fields(1).value, str
    adoRS.MoveNext
end sub

sub TestTwoSets()
    TestDefaultDatabase()
    teardown()
    setup()
    TestDefaultDatabase()
end sub    